<template>
    <view class="container" style="paddingBottom:1rpx;">
      <u-navbar
			leftIconSize="40rpx"
			leftIconColor="#333333"
			title="信用卡还款"
		>
		</u-navbar>
      <view class="section">
        <view class="section-title">{{ title}}</view>
        <view class="form-view">
          <u--form labelPosition="left" :model="form" :rules="rules" ref="uForm" label-width="auto"
            :labelStyle="{ color: '#333333', fontSize: '30rpx' }">
            <u-form-item label="储蓄卡" prop="outAccountName" required @click="handleDebitCard">
              <u--input v-model="form.outAccountName" disabled disabledColor="#ffffff" placeholder="请选择储蓄卡"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item>
            <u-form-item label="信用卡" prop="inAccountName" required @click="handleCreditCard">
              <u--input v-model="form.inAccountName" disabled disabledColor="#ffffff" placeholder="请选择信用卡"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item>
            <u-form-item label="还款时间" prop="createTime" required @click="selectDate()">
              <u--input v-model="form.createTime" disabled disabledColor="#ffffff" placeholder="请选择还款时间" inputAlign="right" border="none"></u--input>
						<u-icon slot="right" name="arrow-right"></u-icon>
            </u-form-item>
            <u-form-item label="还款金额" prop="amount" required >
              <u--input v-model="form.amount"  placeholder="请填写还款金额"
                inputAlign="right" border="none"></u--input>
            </u-form-item>
            <u-form-item label="还款方式" prop="dealTypeName" required @click="handleDealType">
              <u--input v-model="form.dealTypeName" disabled disabledColor="#ffffff" placeholder="请选择还款方式"
                inputAlign="right" border="none"></u--input>
              <u-icon slot="right" name="arrow-down"></u-icon>
            </u-form-item> 
            <u-form-item label="备注" prop="remark"  labelPosition="top">
              <u--textarea v-model="form.remark" placeholder="请填写备注" border="none" autoHeight inputAlign="right" count
                maxlength="20000" style="padding:18rpx 0;"></u--textarea>
            </u-form-item>
          </u--form>
          <view class="form-btn">
            <u-button type="primary" text="提交" @click="submit"></u-button>
          </view>
        </view>
      </view>
      <u-toast ref="uToast"></u-toast>
      <u-picker itemHeight="88" :show="showDebitCard" :columns="debitCardList" keyName="nameCodeAvailableLimit" @cancel="handleDebitCardCancel"
        @confirm="handleDebitCardConfirm"></u-picker>
        <u-picker itemHeight="88" :show="showCreditCard" :columns="bankCardLendList" keyName="nameCodeAvailableLimit" @cancel="handleCreditCardCancel"
        @confirm="handleCreditCardConfirm"></u-picker>
        <u-picker itemHeight="88" :show="showDealType" :columns="dealTypeList" keyName="dictLabel" @cancel="handleDealTypeCancel"
        @confirm="handleDealTypeConfirm"></u-picker>
        <u-datetime-picker
			:show="datePickShow"
			mode="datetime"
      ref="createTimeRef" 
			@cancel="datePickShow=false"
			@confirm="datePickConfirm"
			itemHeight="88"
		></u-datetime-picker>
    </view>
  </template>
  
  <script setup>
  import {getAccountsTransferRecord, addAccountsTransferRecord, updateAccountsTransferRecord } from '@/api/invest/accountsTransferRecord'
import { listAccounts } from '@/api/invest/accounts'
import { getDicts } from '@/api/system/dict/data.js'
  const { proxy } = getCurrentInstance()
  import dayjs from 'dayjs'
  import {onLoad,onReady} from "@dcloudio/uni-app";
    // 计算属性与监听属性是在vue中而非uniap中 需要注意！！！
import {reactive ,toRefs,ref,computed ,getCurrentInstance }from "vue";
const datePickShow = ref(false)
const showDebitCard = ref(false)
const showDealType = ref(false)
const showCreditCard = ref(false)
const title = ref("信用卡还款")
const bankCardLendList = ref([])
const debitCardList = ref([])
const dealTypeList = ref([])
const data = reactive({
  form: {
    id: null,
    name: null,
    type: '2',
    outAccountId: null,
    inAccountId: null,
    posId: null,
    commission: null,
    amount: null,
    actualAmount: null,
    dealType: null,
    createBy: null,
    createTime: null,
    updateBy: null,
    updateTime: null,
    delFlag: null,
    remark: null
  },
  queryDebitCardParams: {
    pageNum: 1,
    type: '1',
    state: '1',
    pageSize: 1000
  },
  queryBankCardLendParams: {
    pageNum: 1,
    type: '2',
    state: '1',
    pageSize: 1000
  },
  rules: {
    inAccountName: [{ required: true, message: '信用卡不能为空', trigger:['change', 'blur'] }],
    outAccountName: [{ required: true, message: '储蓄卡不能为空', trigger: ['change', 'blur'] }],
    dealTypeName: [{ required: true, message: '还款方式不能为空', trigger: ['change', 'blur'] }],
    amount: [{ required: true, message: '还款金额不能为空', trigger: ['change', 'blur'] }],
    createTime: [{ required: true, message: '还款时间不能为空', trigger: ['change', 'blur'] }]
  }
})
const { form, queryDebitCardParams, queryBankCardLendParams, rules} = toRefs(data)


onLoad((option) => {
       form.value.id = option.id
       if(form.value.id!=null){
        title.value="信用卡还款-修改"
       }else{
        title.value="信用卡还款-新增"
       }
      getData()
  })
  onReady(() => {
       form.value.createTime = dayjs(new Date().getTime()).format("YYYY-MM-DD HH:mm:ss")
  })
  function  getData() {
      listAccounts(queryBankCardLendParams.value).then((response) => {
        bankCardLendList.value = [response.rows] 
      })
      listAccounts(queryDebitCardParams.value).then((response) => {
       debitCardList.value = [response.rows] 
       })
           // 类型
           getDicts('credit_repayment_type').then(res => {
        dealTypeList.value =[res.data] 
      })
      if(form.value.id!=null){
        getAccountsTransferRecord(form.value.id).then(res => {
          form.value = res.data   

           // 交易类型
             getDicts('credit_repayment_type').then(result => {
              form.value.amount = res.data.amount   
          form.value.dealTypeName=dictStr(form.value.dealType, result.data)
         })
        })
      }
  }

  function handleDebitCard() {
        if (debitCardList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '储蓄卡为空  ', type: 'warning'
          })
        } else {
          showDebitCard.value = true
        }
     }
  function   handleDebitCardConfirm(e) {
       form.value.outAccountName = e.value[0].nameCodeAvailableLimit
        form.value.outAccountId = e.value[0].id
        showDebitCard.value = false    
  }
 function handleDebitCardCancel() {
       showDebitCard.value = false
    }
function handleCreditCard() {
        if (bankCardLendList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '信用卡为空  ', type: 'warning'
          })
        } else {
          showCreditCard.value = true
        }
     }
  function   handleCreditCardConfirm(e) {
        form.value.inAccountName = e.value[0].nameCodeAvailableLimit
        form.value.inAccountId= e.value[0].id
        showCreditCard.value = false
  }
 function handleCreditCardCancel() {
       showCreditCard.value = false
  }
  function handleDealType() {
        if (dealTypeList.value[0].length === 0) {
          proxy.$refs['uToast'].show({
            message: '交易类型为空  ', type: 'warning'
          })
        } else {
          showDealType.value = true
        }
     }
  function   handleDealTypeConfirm(e) {
        form.value.dealTypeName = e.value[0].dictLabel
        form.value.dealType = e.value[0].dictValue
        showDealType.value = false
  }
 function handleDealTypeCancel() {
       showDealType.value = false
      }
      function dictStr(val, arr) {
      let str = ''
      arr.map(item => {
        if (item.dictValue === val) {
          str = item.dictLabel
        }
      })
      return str
    }
  function  selectDate() {
				datePickShow.value = true
        proxy.$refs['createTimeRef'].innerValue = new Date().getTime()
		}
	function datePickConfirm(e) {
				form.value.createTime = dayjs(e.value).format("YYYY-MM-DD HH:mm:ss")
				datePickShow.value = false
		}
  function submit() {
        proxy.$refs['uForm'].validate().then(() => {
          if (form.value.id != null) {
            updateAccountsTransferRecord(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '修改成功', complete() {
                uni.navigateTo({ url: `/pages/work/accounts/creditTransferRecord/list` })
              }
            })
          })
          }else {
            addAccountsTransferRecord(form.value).then(res => {
              proxy.$refs['uToast'].show({
              message: '新增成功', complete() {
                uni.navigateTo({ url: `/pages/work/accounts/creditTransferRecord/list` })
              }
            })
          })
          }
        })
      }
  </script>
  
  <style lang="scss" scoped>
  .section {
    margin: 24rpx;
    padding: 16rpx 24rpx;
    background-color: #fff;
    border-radius: 8rpx;
  
    .section-title {
      width: 360rpx;
      color: #333333;
      line-height: 44rpx;
      font-size: 30rpx;
      border-left: 6rpx solid #2681FF;
      padding-left: 26rpx;
    }
  
    .form-view {
      padding: 20rpx 0rpx 0 10rpx;
  
      .form-btn {
        padding-top: 20rpx;
      }
    }
  }
  </style>